import com.sun.javafx.collections.MappingChange;
import com.sun.javafx.stage.WindowHelper;
import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.io.InputStream;
import java.lang.Exception;
import java.lang.Integer;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format) {
        return new Outcome(type, format);
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        int k = inf.nextInt();
        Map<Integer, Integer> input = new HashMap<>();
        for (int i = 0; i < n; i++) {
            int x = inf.nextInt();
            if (!input.containsKey(x)) {
                input.put(x, 0);
            }
            input.put(x, input.get(x) + 1);
        }
        try {
            int expected = getAns(k, input, ans, false);
            int actual = getAns(k, input, ouf, true);
            if (expected != actual) {
                return outcome(WA, String.format("Jury found answer %d, but participant found %d", expected, actual));
            }
            return outcome(OK, String.format("n = %d, k = %d, ans = %d", n, k, expected));
        } catch (OutcomeException e) {
            return e.getOutcome();
        }
    }

    static class OutcomeException extends Exception {
        private final Outcome outcome;

        public OutcomeException(Outcome outcome) {
            this.outcome = outcome;
        }

        public Outcome getOutcome() {
            return outcome;
        }
    }

    int getAns(int k, Map<Integer, Integer> _input, InStream stream, boolean checkErrors) throws OutcomeException {
        Map<Integer, Integer> input = new HashMap<>(_input);
        int[] a = new int[k];
        Set<Integer> all = new HashSet<Integer>();
        for (int i = 0; i < k; i++) {
            a[i] = stream.nextInt();
            if (checkErrors && (!input.containsKey(a[i]) || input.get(a[i]) == 0)) {
                throw new OutcomeException(outcome(WA, String.format("%dth participant's ball with color %d were not found in input", i, a[i])));
            }
            input.put(a[i], input.get(a[i]) - 1);
            all.add(a[i]);
        }

        return all.size();
    }
}
