import random
import math
random.seed("personal06_and_rcc_warm_up")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.common_test_number = 0
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):
        self.print_test(3, [[1, 2, 1], [2, 3, 1], [3, 1, 1]], "subtask0", "test from sample", 0, "preliminary")
        self.print_test(4, [[1, 2, 1], [2, 3, 2], [3, 1, 1], [1, 4, 100]], "subtask0", "test from sample", 0, "preliminary")
        self.print_test(4, [[1, 2, 2], [2, 3, 1], [3, 1, 1], [1, 4, 2], [4, 2, 2]], "subtask0", "test from sample", 0, "preliminary")
        self.print_test(2, [[1, 2, 1]], "subtask0", "test from sample", 0, "preliminary")

    def generate_max_test(self, f, maxn, maxk, subtask):
        pass

    def generate_random_test(self, maxn, subtask):
        n = random.randint(2, maxn)
        m = maxn
        edges = []
        for i in range(m):
            v = random.randint(1, n)
            u = random.randint(1, n)
            while v == u:
                v = random.randint(1, n)
                u = random.randint(1, n)
            edges.append([v, u, random.randint(0, 10**9)])
        self.print_test(n, edges, subtask, "n = %d, m = %d" % (n, len(edges)), 0)

    def generate_random_test_with_cycle(self, maxn, subtask):
        n = random.randint(2, maxn)
        m = maxn
        edges = []
        for i in range(n):
            edges.append([i + 1, (i + 1) % n + 1, random.randint(0, 10**9)])
        for i in range(m - n):
            v = random.randint(1, n)
            u = random.randint(1, n)
            while v == u:
                v = random.randint(1, n)
                u = random.randint(1, n)
            edges.append([v, u, random.randint(0, 10**9)])
        self.print_test(n, edges, subtask, "n = %d, m = %d" % (n, len(edges)), 0)

    def generate_many_cycles(self, maxn, subtask, is_random):
        n = random.randint(maxn // 2, maxn)
        if not is_random:
            n = maxn
        m = maxn
        groups = random.randint(1, n // 2)
        nn = n // groups
        v = 1
        edges = []
        for i in range(groups):
            nown = nn
            if i == groups - 1:
                nown = n - nn * (groups - 1)
            for j in range(nown):
                edges.append([v + j, v if (j == nown - 1) else v + j + 1, random.randint(0, 10**9)])
            m -= nown
            v += nown
        for i in range(m):
            v = random.randint(1, n)
            u = random.randint(1, n)
            while v == u:
                v = random.randint(1, n)
                u = random.randint(1, n)
            edges.append([v, u, random.randint(0, 10**9)])
        self.print_test(n, edges, subtask, "n = %d, m = %d" % (n, len(edges)), 0)

    def generate_first_group(self):
        self.print_test(2, [[2, 1, 100]], "subtask1", "n = 2, m = 1", 0)
        self.print_test(3, [[1, 2, 1], [1, 3, 5]], "subtask1", "n = 3, m = 2", 0)
        self.print_test(3, [[1, 2, 5], [1, 3, 1]], "subtask1", "n = 3, m = 2", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300]], "subtask1", "n = 3, m = 3", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300], [2, 3, 200]], "subtask1", "n = 3, m = 4", 0)
        for i in range(5):
            self.generate_random_test(10, "subtask1")
        for i in range(10):
            self.generate_random_test_with_cycle(10, "subtask1")
        for i in range(5):
            self.generate_many_cycles(10, "subtask1", True)
        self.generate_many_cycles(10, "subtask1", False)

    def generate_second_group(self):
        self.print_test(2, [[2, 1, 100]], "subtask2", "n = 2, m = 1", 0)
        self.print_test(3, [[1, 2, 1], [1, 3, 5]], "subtask2", "n = 3, m = 2", 0)
        self.print_test(3, [[1, 2, 5], [1, 3, 1]], "subtask2", "n = 3, m = 2", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300]], "subtask2", "n = 3, m = 3", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300], [2, 3, 200]], "subtask2", "n = 3, m = 4", 0)
        for i in range(5):
            self.generate_random_test(100, "subtask2")
        for i in range(10):
            self.generate_random_test_with_cycle(100, "subtask2")
        for i in range(5):
            self.generate_many_cycles(100, "subtask2", True)
        self.generate_many_cycles(100, "subtask2", False)

    def generate_third_group(self):
        self.print_test(2, [[2, 1, 100]], "subtask3", "n = 2, m = 1", 0)
        self.print_test(3, [[1, 2, 1], [1, 3, 5]], "subtask3", "n = 3, m = 2", 0)
        self.print_test(3, [[1, 2, 5], [1, 3, 1]], "subtask3", "n = 3, m = 2", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300]], "subtask3", "n = 3, m = 3", 0)
        self.print_test(3, [[2, 3, 100], [1, 3, 200], [2, 1, 300], [2, 3, 200]], "subtask3", "n = 3, m = 4", 0)
        for i in range(5):
            self.generate_random_test(100000, "subtask3")
        for i in range(10):
            self.generate_random_test_with_cycle(100000, "subtask3")
        for i in range(5):
            self.generate_many_cycles(100000, "subtask3", True)
        self.generate_many_cycles(100000, "subtask3", False)
        
    def print_test(self, n, edges, subtask, description, points, folder="tests"):
        self.test_number += 1
        m = len(edges)
        print("Generating test %s\%d" % (subtask, self.test_number))

        test_name = "../" + folder + "/{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(n, m, file=test_file)
        print('\n'.join(' '.join(str(element) for element in edge) for edge in edges), file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()                                                                                             

        self.common_test_number += 1
        test_name = "../" + "common" + "/{0:0=2d}".format(self.common_test_number)
        test_file = open(test_name, "w")
        print(n, m, file=test_file)
        print('\n'.join(' '.join(str(element) for element in edge) for edge in edges), file=test_file)
        test_file.close()                                                                                             

    def generate_all_tests(self):
        self.generate_samples()
        self.test_number = 0

        #First group of tests
        self.generate_first_group()       #tests 01-##
        print("comment_subtask1=\"n, m &lt;= 10\"", file=self.desc_file)
        print("bonus_subtask1=20", file=self.desc_file)

        #Second group of tests
        self.generate_second_group()      #tests ##-##
        print("comment_subtask2=\"n, m &lt;= 100 \"", file=self.desc_file)
        print("bonus_subtask2=40", file=self.desc_file)
        
        #Third group of tests
        self.generate_third_group()       #tests ##-##
        print("comment_subtask3=\"n, m &lt;= 100000\"", file=self.desc_file)
        print("bonus_subtask3=40", file=self.desc_file)

        self.desc_file.close()

import os, shutil
if os.path.exists('../preliminary'):
    print('Directory preliminary already exists')
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
if os.path.exists('../tests'):
    print('Directory tests already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
if os.path.exists('../common'):
    print('Directory common already exists')
    shutil.rmtree('../common', ignore_errors=False, onerror=None)
try:
    os.makedirs('../preliminary')
    os.makedirs('../tests')
    os.makedirs('../common')
except OSError:                                                                                                                      
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
