import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by pva701 on 2/26/15.
 */

public class parade_ip {
    public static final String TASK = "parade";
    public static final int INF = 1000000000;
    public static final int K = 30;

    FastScanner in;
    PrintWriter out;

    public static int MAX_PRIME = 10000000;
    private boolean[] p = new boolean[MAX_PRIME + 1];
    private int[] pr = new int[700000];
    private int sz;
    public void solve() throws IOException {
        int k = in.nextInt();
        int n = in.nextInt();
        for (int i = 2; i * i <= MAX_PRIME; ++i)
            if (!p[i])
                for (int j = i * i; j <= MAX_PRIME; j += i)
                    p[j] = true;
        for (int i = 2; i <= MAX_PRIME; ++i)
            if (!p[i]) pr[sz++] = i;
        if (sz < k || k > n * n)
            out.println(-1);
        else if (k <= n) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j)
                    out.print(pr[(i + j) % k] + " ");
                out.println();
            }
        } else {
            int i = 0, j = 0;
            for (; i < n && n * n - i * n - j > k - n; ) {
                for (j = 0; j < n && n * n - i * n - j > k - n; ++j)
                    out.print(pr[(i + j) % n] + " ");
                if (j == n) {
                    out.println();
                    j = 0;
                    ++i;
                }
            }

            int s = n;
            for (; i < n; ++i) {
                for (; j < n; ++j)
                    out.print(pr[s++] + " ");
                out.println();
                j = 0;
            }
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK + ".in"));
            out = new PrintWriter(new File(TASK + ".out"));
            long l = System.currentTimeMillis();
            solve();
            long r = System.currentTimeMillis();
            System.err.println("time = " + (r - l) / 1000.0);
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new parade_ip().run();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}
